s_scalbn.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for s_scalbn.c:

Go to the source code of this file.

## Functions

| libm_hidden_proto (copysign)

## Function Documentation

libm_hidden_proto | ( | copysign |  | ) |

Definition at line 28 of file s_scalbn.c.

References copysign, EXTRACT_WORDS, GET_HIGH_WORD, huge_val, libm_hidden_def, scalbn, SET_HIGH_WORD, tiny, and two54.

{
int32_t k, hx, lx;
EXTRACT_WORDS(hx, lx, x);
k = (hx & 0x7ff00000) >> 20; /* extract exponent */
if (k == 0) { /* 0 or subnormal x */
if ((lx | (hx & 0x7fffffff)) == 0)
return x; /* +-0 */
x *= two54;
GET_HIGH_WORD(hx, x);
k = ((hx & 0x7ff00000) >> 20) - 54;
if (n < -50000)
return tiny * x; /* underflow */
}
if (k == 0x7ff)
return x + x; /* NaN or Inf */
k = k + n;
if (k > 0x7fe)
return huge_val * copysign(huge_val, x); /* overflow */
if (k > 0) { /* normal result */
SET_HIGH_WORD(x, (hx & 0x800fffff) | (k << 20));
return x;
}
if (k <= -54) {
if (n > 50000) /* in case integer overflow in n+k */
return huge_val * copysign(huge_val, x); /* overflow */
else
return tiny * copysign(tiny, x); /* underflow */
}
k += 54; /* subnormal result */
SET_HIGH_WORD(x, (hx & 0x800fffff) | (k << 20));
return x * twom54;
}
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:103
n
GLdouble n
Definition: SDL_opengl_glext.h:1952
int32_t
signed int int32_t
Definition: SDL_config_windows.h:61
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
tiny
tiny
Definition: e_pow.c:79
SET_HIGH_WORD
#define SET_HIGH_WORD(d, v)
Definition: math_private.h:131
EXTRACT_WORDS
#define EXTRACT_WORDS(ix0, ix1, d)
Definition: math_private.h:93
two54
static double two54
Definition: e_log.c:79
huge_val
huge_val
Definition: e_pow.c:79
copysign
#define copysign
Definition: math_private.h:34